<?php

class node_gallery_handler_field_fid extends views_handler_field {
  
  function construct() {
    parent::construct();
    //$this->additional_fields['gid'] = 'gid';
    $this->additional_fields['nid'] = 'nid';
  }
  
  function option_definition() {
    $options = parent::option_definition();
    $options['node_gallery_setting'] = '';
    return $options;
  }
  
  function options_form(&$form, &$form_state) {
    $configs = node_gallery_get_config();
    foreach ($configs as $gallery_type => $config) {
      $options[$gallery_type] = $config['name'];
    }
    
    parent::options_form($form, $form_state);
    $form['node_gallery_setting'] = array(
      '#title' => t('Specify Node Gallery Setting'),
      '#description' => t('Specify which node gallery settings you want to use.'),
      '#type' => 'select',
      '#default_value' => $this->options['node_gallery_setting'],
      '#options' => $options,
    );
  }
  
  function pre_render(&$values) {
    foreach ($values as $value) {
      $fids[$value->{$this->aliases[$this->additional_fields['nid']]}] = $value->{$this->field_alias};
    }
    if (!empty($fids)) {
      $result = db_query("SELECT ng.*, f.filepath FROM {node_galleries} ng INNER JOIN {files} f ON ng.fid = f.fid 
        WHERE ng.fid IN (". db_placeholders($fids) .")", $fids);
      while ($r = db_fetch_array($result)) {
        $items[$r['nid']] = $r;
      }
      foreach ($values as $value) {
        $new = array_merge((array)$value, $items[$value->{$this->aliases[$this->additional_fields['nid']]}]);
        $new_items[] = (object)$new;
      }
      $values = $new_items;
    }
  }
  
  function render($value) {
    $config = node_gallery_get_config($this->options['node_gallery_setting']);
    return theme('gallery_list_image', $value, $config);
  }
}